//
//  ListsTableViewCell.m
//  表格点击展开的cell
//
//  Created by ZXL on 2017/4/28.
//  Copyright © 2017年 zxl. All rights reserved.
//

#import "ListsTableViewCell.h"
#import "ListTableViewCell.h"
#import <Masonry/Masonry.h>

@interface ListsTableViewCell ()<UITableViewDataSource,UITableViewDelegate>

/** 表格 */
@property (nonatomic ,strong) UITableView * tableView;

/** contentView */
@property (nonatomic ,strong) UIView * innerContentView;


@end

@implementation ListsTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];

    if (self) {
        
        [self.contentView addSubview:self.innerContentView];
        _innerContentView.backgroundColor = [UIColor redColor];
        
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.scrollEnabled = YES;
        [_tableView registerNib:[UINib nibWithNibName:NSStringFromClass([ListTableViewCell class]) bundle:nil] forCellReuseIdentifier:@"listcell"];
        [self.innerContentView addSubview:self.tableView];
    
    }
    
    return self;
}

- (void)layoutSubviews{
    [super layoutSubviews];
    
    __weak typeof(self) weakSelf = self;
    [self.innerContentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(weakSelf).with.offset(3);
        make.bottom.equalTo(weakSelf).with.offset(-3);
        make.left.mas_equalTo(weakSelf).with.offset(10);
        make.right.mas_equalTo(weakSelf).with.offset(-10);
    }];
    
    NSLog(@"%@",NSStringFromCGRect(self.innerContentView.frame));
    
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.bottom.right.equalTo(weakSelf.innerContentView);
    }];
    
}

- (UIView *)innerContentView{
    if (!_innerContentView) {
        _innerContentView = [[UIView alloc]initWithFrame:CGRectZero];
        _innerContentView.layer.cornerRadius = 8;
        _innerContentView.layer.borderColor = [UIColor orangeColor].CGColor;
        _innerContentView.layer.borderWidth = 1;
        _innerContentView.layer.masksToBounds = YES;
    }
    return _innerContentView;
}


- (void)setDataSource:(NSArray *)dataSource{
    _dataSource = dataSource;
    [self.tableView reloadData];
}

#pragma mark - 数据源代理
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.dataSource.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString * ID = @"listcell";
    
    ListTableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:ID forIndexPath:indexPath];
    
    cell.listTable.text = [NSString stringWithFormat:@"地址%ld",(long)indexPath.row];
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (self.SelectBlock) {
        self.SelectBlock(indexPath.row);
    }
}

@end
