//
//  ViewController.m
//  表格点击展开的cell
//
//  Created by ZXL on 2017/4/28.
//  Copyright © 2017年 zxl. All rights reserved.
//

#import "ViewController.h"

#import "ListTableViewCell.h"
#import "ListsTableViewCell.h"

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource>

/** UITableView */
@property (nonatomic ,strong) UITableView * tableView;

/** 行数 */
@property (nonatomic ,assign) NSInteger rows;


@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"表格点击展开的cell";
    
    self.tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 64, self.view.frame.size.width, self.view.frame.size.height - 64)];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    [_tableView registerNib:[UINib nibWithNibName:NSStringFromClass([ListTableViewCell class]) bundle:nil] forCellReuseIdentifier:@"listCell"];
    [_tableView registerClass:[ListsTableViewCell class] forCellReuseIdentifier:@"listsCell"];
    _tableView.rowHeight = 50;
    
    [self.view addSubview:self.tableView];
    
    self.automaticallyAdjustsScrollViewInsets = NO;
    
    self.rows = 15;
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - 数据源代理
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.rows;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    // 展开的行
    if (self.rows == 16 && indexPath.row == 3) {
        ListsTableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"listsCell" forIndexPath:indexPath];
        cell.dataSource = @[@"1",@"2",@"3",@"1",@"2",@"3"];
        
        // 内部的表格选中了一行回调
        __block ListsTableViewCell * weakCell = cell;
        __weak typeof(self) weakSelf = self;
        cell.SelectBlock = ^(NSInteger index) {
            NSLog(@"--- %@",weakCell.dataSource[index]);
            
            if (weakSelf.rows == 16) {
                weakSelf.rows --;
                [weakSelf.tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationBottom];
            }
            
        };
        
        return cell;
    }
    
    ListTableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"listCell" forIndexPath:indexPath];
    
    if (indexPath.row != 2) {
        cell.listTable.text = [NSString stringWithFormat:@"列表%ld",(long)indexPath.row];
    }
    
    cell.backgroundColor = [UIColor colorWithRed:242 / 255.0 green:242 / 255.0 blue:242 / 255.0 alpha:1];
    
    return cell;
    
    

}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (indexPath.row == 2 ) {
        NSIndexPath * path = [NSIndexPath indexPathForRow:3 inSection:0];
        if (self.rows == 16) {
            self.rows --;
            [self.tableView deleteRowsAtIndexPaths:@[path] withRowAnimation:UITableViewRowAnimationBottom];
        }
        else{
            self.rows ++;
            [self.tableView insertRowsAtIndexPaths:@[path] withRowAnimation:UITableViewRowAnimationTop];
        }
    }
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    if (self.rows == 16 && indexPath.row == 3) {
        return 280;
    }
    return 50;
}


@end
